import _classPrivateFieldGet from "@babel/runtime/helpers/esm/classPrivateFieldGet";
import _classPrivateFieldSet from "@babel/runtime/helpers/esm/classPrivateFieldSet";

function _classPrivateFieldInitSpec(obj, privateMap, value) { _checkPrivateRedeclaration(obj, privateMap); privateMap.set(obj, value); }

function _checkPrivateRedeclaration(obj, privateCollection) { if (privateCollection.has(obj)) { throw new TypeError("Cannot initialize the same private elements twice on an object"); } }

var _resolver = /*#__PURE__*/new WeakMap();

export class RoutePathResolver {
  static getFromBuilder(builder) {
    return new RoutePathResolver(builder.getBuilderLink().resolver);
  }

  constructor(resolver) {
    _classPrivateFieldInitSpec(this, _resolver, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldSet(this, _resolver, resolver);
  }

  resolve(location) {
    return _classPrivateFieldGet(this, _resolver).resolve(location).filter(isResultWithAction);
  }
  /**
   * Resolve given location and return the result of running associated action.
   * If multiple locations are resolved, the first one is used.
   */


  resolveAction(location) {
    const res = this.resolve(location)[0];

    if (res === undefined) {
      return undefined;
    }

    const result = res.route.action(res.match);
    return {
      route: res.route,
      result
    };
  }

}

function isResultWithAction(res) {
  return !!res.route.action;
}