import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _classPrivateFieldSet from "@babel/runtime/helpers/esm/classPrivateFieldSet";
import _classPrivateFieldGet from "@babel/runtime/helpers/esm/classPrivateFieldGet";

function _classPrivateFieldInitSpec(obj, privateMap, value) { _checkPrivateRedeclaration(obj, privateMap); privateMap.set(obj, value); }

function _checkPrivateRedeclaration(obj, privateCollection) { if (privateCollection.has(obj)) { throw new TypeError("Cannot initialize the same private elements twice on an object"); } }

import { RouteRecordBase } from "./RouteRecordBase";
/**
 * Special route definition for wildcard route.
 */

var _validator = /*#__PURE__*/new WeakMap();

/**
 * Object for wildcard route in RouteBuilder.
 */
export class MatchingRouteRecord extends RouteRecordBase {
  constructor(parent, matchKey, validator, action) {
    super(parent.getBuilderLink(), action, match => {
      const matchedValue = match[this.key];

      if (!_classPrivateFieldGet(this, _validator).call(this, matchedValue)) {
        throw new Error("Invariant failure: type of '".concat(matchedValue, "' is wrong"));
      }

      return matchedValue;
    });

    _defineProperty(this, "key", void 0);

    _classPrivateFieldInitSpec(this, _validator, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldSet(this, _validator, validator);

    this.key = matchKey;
  }

}