import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _classPrivateFieldGet from "@babel/runtime/helpers/esm/classPrivateFieldGet";
import _classPrivateFieldSet from "@babel/runtime/helpers/esm/classPrivateFieldSet";

function _classPrivateFieldInitSpec(obj, privateMap, value) { _checkPrivateRedeclaration(obj, privateMap); privateMap.set(obj, value); }

function _checkPrivateRedeclaration(obj, privateCollection) { if (privateCollection.has(obj)) { throw new TypeError("Cannot initialize the same private elements twice on an object"); } }

import { BuilderLink } from "../../core/BuilderLink";
import { isString, isStringOrUndefined } from "../../validator";
import { SearchLocationComposer } from "../composers/SearchLocationComposer";
import { MatchingRouteRecord } from "../RouteRecord/MatchingRouteRecord";
import { SingleRouteAbstractBuilder } from "../SingleRouteAbstractBuilder";

var _link = /*#__PURE__*/new WeakMap();

var _route = /*#__PURE__*/new WeakMap();

export class SearchRouteBuilder extends SingleRouteAbstractBuilder {
  static init(matchKey, options = {}) {
    var _options$searchKey;

    const searchKey = (_options$searchKey = options.searchKey) !== null && _options$searchKey !== void 0 ? _options$searchKey : matchKey;
    const optional = options.optional || false;
    const link = new BuilderLink({
      composer: new SearchLocationComposer(searchKey, optional)
    });
    const result = new SearchRouteBuilder(link, matchKey, optional);
    return result;
  }

  constructor(link, matchKey, optional) {
    super();

    _defineProperty(this, "matchKey", void 0);

    _defineProperty(this, "optional", void 0);

    _classPrivateFieldInitSpec(this, _link, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _route, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldSet(this, _link, link);

    this.matchKey = matchKey;
    this.optional = optional;

    _classPrivateFieldSet(this, _route, new MatchingRouteRecord(this, matchKey, optional ? isStringOrUndefined : isString, undefined));

    link.register(this, value => {
      const route = _classPrivateFieldGet(this, _route);

      return {
        type: "matching",
        value: route,
        link: route.getAttachedBuilderLink(),
        matchKey: matchKey,
        matchValue: value
      };
    });
  }
  /**
   * Define action for this route and return a new instance of SearchRouteBuilder.
   */


  action(action) {
    const result = new SearchRouteBuilder(_classPrivateFieldGet(this, _link).inherit(), this.matchKey, this.optional);

    _classPrivateFieldSet(result, _route, new MatchingRouteRecord(result, this.matchKey, this.optional ? isStringOrUndefined : isString, action));

    return result;
  }
  /**
   * Get a route object of this builder.
   */


  getRoute() {
    return _classPrivateFieldGet(this, _route);
  }

  getBuilderLink() {
    return _classPrivateFieldGet(this, _link);
  }

}