import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";

/**
 * LocationComposer that composes to a constant location.
 */
export class ConstLocationComposer {
  constructor(location) {
    _defineProperty(this, "location", void 0);

    this.location = location;
  }

  isLeaf() {
    return false;
  }

  compose() {
    return this.location;
  }

  decompose(base) {
    return [{
      leaf: false,
      segment: undefined,
      nextLocation: base
    }];
  }

}