import { composePath } from "./composePath";
import { decomposePath } from "./decomposePath";
export class PathLocationComposer {
  isLeaf(location) {
    return location.pathname === "/";
  }

  compose(base, segment) {
    if (segment === undefined) {
      return base;
    }

    return { ...base,
      pathname: composePath(base.pathname, segment)
    };
  }

  decompose(location) {
    const {
      pathname
    } = location;
    const s = decomposePath(pathname);
    const current = {
      leaf: true,
      segment: undefined,
      nextLocation: location
    };

    if (s === undefined) {
      return [current];
    }

    const [segment, next] = s;
    const nextLocation = { ...location,
      pathname: next || "/"
    };
    return [current, {
      leaf: false,
      segment,
      nextLocation: nextLocation
    }];
  }

}