import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
export class SingleHashLocationComposer {
  constructor(optional) {
    _defineProperty(this, "optional", void 0);

    this.optional = optional;
  }

  isLeaf(location) {
    return !location.hash;
  }

  compose(base, segment) {
    return { ...base,
      hash: segment !== undefined ? "#" + segment : ""
    };
  }

  decompose(location) {
    const {
      hash
    } = location;

    if (!(hash !== null && hash !== void 0 && hash.startsWith("#"))) {
      if (this.optional) {
        return [{
          leaf: false,
          segment: undefined,
          nextLocation: location
        }];
      } else {
        return [];
      }
    }

    const nextLocation = { ...location,
      hash: ""
    };
    return [{
      leaf: false,
      // string is always valid as segment but TS does not allow it
      segment: hash.slice(1),
      nextLocation: nextLocation
    }];
  }

}