import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
export class StateLocationComposer {
  constructor(key, validator, optional) {
    _defineProperty(this, "key", void 0);

    _defineProperty(this, "optional", void 0);

    _defineProperty(this, "validator", void 0);

    this.key = key;
    this.optional = optional;
    this.validator = validator;
  }

  isLeaf(location) {
    var _location$state;

    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    return ((_location$state = location.state) === null || _location$state === void 0 ? void 0 : _location$state[this.key]) === undefined;
  }

  compose(base, segment) {
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    const newState = { ...base.state,
      [this.key]: segment
    };
    return { ...base,
      state: newState
    };
  }

  decompose(location) {
    const {
      state
    } = location; // eslint-disable-next-line @typescript-eslint/no-explicit-any

    const value = state === null || state === void 0 ? void 0 : state[this.key];

    if (value === undefined) {
      if (this.optional) {
        return [{
          leaf: false,
          segment: undefined,
          nextLocation: location
        }];
      } else {
        return [];
      }
    }

    if (!this.validator(value)) {
      return [];
    } // eslint-disable-next-line @typescript-eslint/no-unused-vars


    const {
      [this.key]: _,
      ...rest
    } = state;
    const nextLocation = { ...location,
      state: rest
    };
    return [{
      leaf: false,
      segment: value,
      nextLocation
    }];
  }

}