import { createBrowserHistory } from "history";
import React, { memo, useEffect, useMemo, useState } from "react";
import { HistoryContext } from "../contexts/HistoryContext";
import { LocationContext } from "../contexts/LocationContext";
export const RoconRoot = /*#__PURE__*/memo(props => {
  const history = useMemo(() => props.history || createBrowserHistory(), [props.history]);
  const historyContextValue = useMemo(() => {
    return {
      history
    };
  }, [history]);
  const [location, setLocation] = useState(history.location);
  useEffect(() => {
    // this `setLocation` handles the case where location is changed after above `history.location` is calculated
    setLocation(history.location);
    return history.listen(state => {
      setLocation(state.location);
    });
  }, [history]);
  return /*#__PURE__*/React.createElement(HistoryContext.Provider, {
    value: historyContextValue
  }, /*#__PURE__*/React.createElement(LocationContext.Provider, {
    value: location
  }, props.children));
});