import { AttachableRouteBuilder, RouteBuilderLink } from "../RouteBuilderLink";
import { PathRouteRecord, RoutesDefinitionToRouteRecords } from "../RouteRecord";
import { MatchingRouteRecord } from "../RouteRecord/MatchingRouteRecord";
import type { RouteDefinition, RoutesDefinition } from "../RoutesDefinitionObject";
import type { ActionTypeToWildcardFlag, ExistingWildcardFlagType, WildcardFlagType } from "../WildcardFlagType";
import type { PathSingleRouteInterface } from "./PathSingleRouteInterface";
declare type AnyRouteType<ActionResult, WildcardFlag extends WildcardFlagType, Match> = WildcardFlag extends ExistingWildcardFlagType ? MatchingRouteRecord<ActionResult, string, Match, WildcardFlag extends "hasaction" ? true : false> : undefined;
declare type ExactRouteType<ActionResult, WildcardFlag extends WildcardFlagType, Match> = WildcardFlag extends ExistingWildcardFlagType ? PathRouteRecord<ActionResult, Match, WildcardFlag extends "hasaction" ? true : false> : undefined;
export declare class PathRouteBuilder<ActionResult, Defs extends RoutesDefinition<ActionResult>, AnyFlag extends WildcardFlagType, ExactFlag extends WildcardFlagType, Match, AnyMatch = Match> implements AttachableRouteBuilder<ActionResult, string | undefined> {
    #private;
    static init<ActionResult>(): PathRouteBuilder<ActionResult, {}, "none", "none", {}, {}>;
    private constructor();
    routes<D extends RoutesDefinition<ActionResult>>(defs: D): PathRouteBuilder<ActionResult, Omit<Defs, keyof D> & D, AnyFlag, ExactFlag, Match, AnyMatch>;
    route<Key extends string>(key: Key, callback?: (route: PathSingleRouteInterface<ActionResult, Match>) => void): PathRouteBuilder<ActionResult, Key extends keyof Defs ? {
        [K in keyof Defs]: Key extends K ? RouteDefinition<ActionResult, Match> : Defs[K];
    } : {
        [K in keyof Defs | Key]: K extends keyof Defs ? Defs[K] : RouteDefinition<ActionResult, Match>;
    }, AnyFlag, ExactFlag, Match, AnyMatch>;
    any<Key extends string, RD extends RouteDefinition<ActionResult, AnyMatch & {
        [K in Key]: string;
    }>>(key: Key, routeDefinition?: RD): PathRouteBuilder<ActionResult, Defs, ActionTypeToWildcardFlag<RD["action"]>, ExactFlag, Match, AnyMatch & {
        [K in Key]: string;
    }>;
    exact<RD extends RouteDefinition<ActionResult, Match>>(routeDefinition: RD): PathRouteBuilder<ActionResult, Defs, AnyFlag, ActionTypeToWildcardFlag<RD["action"]>, Match, AnyMatch>;
    getRoutes(): Readonly<RoutesDefinitionToRouteRecords<ActionResult, Defs, Match>>;
    get _(): Readonly<RoutesDefinitionToRouteRecords<ActionResult, Defs, Match>>;
    get anyRoute(): AnyRouteType<ActionResult, AnyFlag, AnyMatch>;
    get exactRoute(): ExactRouteType<ActionResult, ExactFlag, Match>;
    getBuilderLink(): RouteBuilderLink<ActionResult, string | undefined>;
}
export {};
//# sourceMappingURL=index.d.ts.map