import { Location } from "../../core/Location";
import { AttachableRouteBuilder, RouteBuilderLink } from "../RouteBuilderLink";
import { ConstRouteRecord } from "../RouteRecord/ConstRouteRecord";
import { ActionType } from "../RoutesDefinitionObject";
import { SingleRouteAbstractBuilder } from "../SingleRouteAbstractBuilder";
import { ExistingWildcardFlagType, WildcardFlagToHasAction } from "../WildcardFlagType";
export declare type RootRouteBuilderOptions = {
    root: Location;
};
export declare class RootRouteBuilder<ActionResult, WildcardFlag extends ExistingWildcardFlagType, Match> extends SingleRouteAbstractBuilder<ActionResult, Match, WildcardFlagToHasAction<WildcardFlag>> implements AttachableRouteBuilder<ActionResult, unknown> {
    #private;
    static init<ActionResult>(options?: Partial<RootRouteBuilderOptions>): RootRouteBuilder<ActionResult, "noaction", {}>;
    private constructor();
    action(action: ActionType<ActionResult, Match>): RootRouteBuilder<ActionResult, "hasaction", Match>;
    getRoute(): ConstRouteRecord<ActionResult, Match, WildcardFlagToHasAction<WildcardFlag>>;
    getBuilderLink(): RouteBuilderLink<ActionResult, unknown>;
}
//# sourceMappingURL=index.d.ts.map