"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SearchRouteBuilder = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classPrivateFieldGet2 = _interopRequireDefault(require("@babel/runtime/helpers/classPrivateFieldGet"));

var _classPrivateFieldSet2 = _interopRequireDefault(require("@babel/runtime/helpers/classPrivateFieldSet"));

var _BuilderLink = require("../../core/BuilderLink");

var _validator = require("../../validator");

var _SearchLocationComposer = require("../composers/SearchLocationComposer");

var _MatchingRouteRecord = require("../RouteRecord/MatchingRouteRecord");

var _SingleRouteAbstractBuilder = require("../SingleRouteAbstractBuilder");

function _classPrivateFieldInitSpec(obj, privateMap, value) { _checkPrivateRedeclaration(obj, privateMap); privateMap.set(obj, value); }

function _checkPrivateRedeclaration(obj, privateCollection) { if (privateCollection.has(obj)) { throw new TypeError("Cannot initialize the same private elements twice on an object"); } }

var _link = /*#__PURE__*/new WeakMap();

var _route = /*#__PURE__*/new WeakMap();

class SearchRouteBuilder extends _SingleRouteAbstractBuilder.SingleRouteAbstractBuilder {
  static init(matchKey, options = {}) {
    var _options$searchKey;

    const searchKey = (_options$searchKey = options.searchKey) !== null && _options$searchKey !== void 0 ? _options$searchKey : matchKey;
    const optional = options.optional || false;
    const link = new _BuilderLink.BuilderLink({
      composer: new _SearchLocationComposer.SearchLocationComposer(searchKey, optional)
    });
    const result = new SearchRouteBuilder(link, matchKey, optional);
    return result;
  }

  constructor(link, matchKey, optional) {
    super();
    (0, _defineProperty2.default)(this, "matchKey", void 0);
    (0, _defineProperty2.default)(this, "optional", void 0);

    _classPrivateFieldInitSpec(this, _link, {
      writable: true,
      value: void 0
    });

    _classPrivateFieldInitSpec(this, _route, {
      writable: true,
      value: void 0
    });

    (0, _classPrivateFieldSet2.default)(this, _link, link);
    this.matchKey = matchKey;
    this.optional = optional;
    (0, _classPrivateFieldSet2.default)(this, _route, new _MatchingRouteRecord.MatchingRouteRecord(this, matchKey, optional ? _validator.isStringOrUndefined : _validator.isString, undefined));
    link.register(this, value => {
      const route = (0, _classPrivateFieldGet2.default)(this, _route);
      return {
        type: "matching",
        value: route,
        link: route.getAttachedBuilderLink(),
        matchKey: matchKey,
        matchValue: value
      };
    });
  }
  /**
   * Define action for this route and return a new instance of SearchRouteBuilder.
   */


  action(action) {
    const result = new SearchRouteBuilder((0, _classPrivateFieldGet2.default)(this, _link).inherit(), this.matchKey, this.optional);
    (0, _classPrivateFieldSet2.default)(result, _route, new _MatchingRouteRecord.MatchingRouteRecord(result, this.matchKey, this.optional ? _validator.isStringOrUndefined : _validator.isString, action));
    return result;
  }
  /**
   * Get a route object of this builder.
   */


  getRoute() {
    return (0, _classPrivateFieldGet2.default)(this, _route);
  }

  getBuilderLink() {
    return (0, _classPrivateFieldGet2.default)(this, _link);
  }

}

exports.SearchRouteBuilder = SearchRouteBuilder;