import type { PartialIf } from "../../util/types/PartialIf";
import { AttachableRouteBuilder, RouteBuilderLink } from "../RouteBuilderLink";
import { RouteRecordType } from "../RouteRecord";
import { ActionType } from "../RoutesDefinitionObject";
import { SingleRouteAbstractBuilder } from "../SingleRouteAbstractBuilder";
import type { ExistingWildcardFlagType, WildcardFlagToHasAction } from "../WildcardFlagType";
export declare type SingleHashRouteBuilderOptions<IsOptional extends boolean> = {
    optional?: IsOptional;
};
export declare class SingleHashRouteBuilder<ActionResult, WildcardFlag extends ExistingWildcardFlagType, Match> extends SingleRouteAbstractBuilder<ActionResult, Match, WildcardFlagToHasAction<WildcardFlag>> implements AttachableRouteBuilder<ActionResult, string | undefined> {
    #private;
    static init<ActionResult, Key extends string, IsOptional extends boolean = false>(matchKey: Key, options?: SingleHashRouteBuilderOptions<IsOptional>): SingleHashRouteBuilder<ActionResult, "noaction", PartialIf<IsOptional, {
        [K in Key]: string;
    }>>;
    readonly matchKey: Extract<keyof Match, string>;
    readonly optional: boolean;
    private constructor();
    action(action: ActionType<ActionResult, Match>): SingleHashRouteBuilder<ActionResult, "hasaction", Match>;
    getRoute(): RouteRecordType<ActionResult, Match, WildcardFlagToHasAction<WildcardFlag>>;
    getBuilderLink(): RouteBuilderLink<ActionResult, string | undefined>;
}
//# sourceMappingURL=index.d.ts.map