import type { OptionalIf } from "../../util/types/OptionalIf";
import type { PartialIf } from "../../util/types/PartialIf";
import { Validator } from "../../validator";
import type { AttachableRouteBuilder, RouteBuilderLink } from "../RouteBuilderLink";
import type { RouteRecordType } from "../RouteRecord";
import type { ActionType } from "../RoutesDefinitionObject";
import { SingleRouteAbstractBuilder } from "../SingleRouteAbstractBuilder";
import type { ExistingWildcardFlagType, WildcardFlagToHasAction } from "../WildcardFlagType";
export declare type StateRouteBuilerOptions<IsOptional extends boolean> = {
    stateKey?: string;
    optional?: IsOptional;
};
export declare class StateRouteBuilder<ActionResult, StateValue, WildcardFlag extends ExistingWildcardFlagType, Match> extends SingleRouteAbstractBuilder<ActionResult, Match, WildcardFlagToHasAction<WildcardFlag>> implements AttachableRouteBuilder<ActionResult, StateValue | undefined> {
    #private;
    static init<ActionResult, StateValue, Key extends string, IsOptional extends boolean = false>(matchKey: Key, validator: Validator<StateValue>, options?: StateRouteBuilerOptions<IsOptional>): StateRouteBuilder<ActionResult, OptionalIf<IsOptional, StateValue>, "noaction", PartialIf<IsOptional, {
        [K in Key]: StateValue;
    }>>;
    readonly matchKey: Extract<keyof Match, string>;
    private constructor();
    action(action: ActionType<ActionResult, Match>): StateRouteBuilder<ActionResult, StateValue, "hasaction", Match>;
    getRoute(): RouteRecordType<ActionResult, Match, WildcardFlagToHasAction<WildcardFlag>>;
    getBuilderLink(): RouteBuilderLink<ActionResult, StateValue | undefined>;
}
//# sourceMappingURL=index.d.ts.map