import type { BaseState, Location } from "../../../core/Location";
import type { DecomposeResult, LocationComposer } from "../../../core/LocationComposer";
import type { OptionalIf } from "../../../util/types/OptionalIf";
export declare class SearchLocationComposer<IsOptional extends boolean> implements LocationComposer<OptionalIf<IsOptional, string>> {
    readonly key: string;
    readonly optional: IsOptional;
    constructor(key: string, optional: IsOptional);
    isLeaf(location: Readonly<Location>): boolean;
    compose<S extends BaseState>(base: Readonly<Location<S>>, segment: OptionalIf<IsOptional, string>): Location<S>;
    decompose<S extends BaseState>(location: Readonly<Location<S>>): Array<DecomposeResult<OptionalIf<IsOptional, string>, S>>;
}
//# sourceMappingURL=index.d.ts.map