"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SingleHashLocationComposer = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

class SingleHashLocationComposer {
  constructor(optional) {
    (0, _defineProperty2.default)(this, "optional", void 0);
    this.optional = optional;
  }

  isLeaf(location) {
    return !location.hash;
  }

  compose(base, segment) {
    return { ...base,
      hash: segment !== undefined ? "#" + segment : ""
    };
  }

  decompose(location) {
    const {
      hash
    } = location;

    if (!(hash !== null && hash !== void 0 && hash.startsWith("#"))) {
      if (this.optional) {
        return [{
          leaf: false,
          segment: undefined,
          nextLocation: location
        }];
      } else {
        return [];
      }
    }

    const nextLocation = { ...location,
      hash: ""
    };
    return [{
      leaf: false,
      // string is always valid as segment but TS does not allow it
      segment: hash.slice(1),
      nextLocation: nextLocation
    }];
  }

}

exports.SingleHashLocationComposer = SingleHashLocationComposer;