import type { BaseState, Location } from "../../../core/Location";
import type { DecomposeResult, LocationComposer } from "../../../core/LocationComposer";
import { OptionalIf } from "../../../util/types/OptionalIf";
import type { Validator } from "../../../validator";
export declare class StateLocationComposer<Key extends string, StateValue, IsOptional extends boolean> implements LocationComposer<OptionalIf<IsOptional, StateValue>> {
    readonly key: Key;
    readonly optional: IsOptional;
    readonly validator: Validator<OptionalIf<IsOptional, StateValue>>;
    constructor(key: Key, validator: Validator<OptionalIf<IsOptional, StateValue>>, optional: IsOptional);
    isLeaf(location: Readonly<Location>): boolean;
    compose<S extends BaseState>(base: Readonly<Location<S>>, segment: OptionalIf<IsOptional, StateValue>): Location<S>;
    decompose<S extends BaseState>(location: Readonly<Location<S>>): Array<DecomposeResult<OptionalIf<IsOptional, StateValue>, Omit<S, Key>>>;
}
//# sourceMappingURL=index.d.ts.map