import { Location } from "../Location";
import type { LocationComposer } from "../LocationComposer";
import { RouteResolver } from "../RouteResolver";
import { SegmentDecomposer } from "../RouteResolver/resolveChain";
import type { BuilderLinkOptions } from "./BuilderLinkOptions";
import { HasBuilderLink } from "./HasBuilderLink";
import { SegmentResolver } from "./SegmentResolver";
export declare class BuilderLink<ActionResult, Segment, Value> implements HasBuilderLink<ActionResult, Segment, Value> {
    #private;
    readonly composer: LocationComposer<Segment>;
    resolver: RouteResolver<ActionResult, Segment, Value>;
    currentBuilder?: HasBuilderLink<ActionResult, Segment, Value>;
    segmentDecomposer?: SegmentDecomposer<ActionResult, Segment, Value>;
    constructor(options: BuilderLinkOptions<Segment>);
    attachToParent(parentLink: BuilderLink<ActionResult, Segment, Value>, segmentGetter: (match: unknown) => Segment): void;
    private collectUpToTop;
    composeFromTop(defaultRoot: Location, match: unknown): Location;
    getAttachmentRoot(): BuilderLink<ActionResult, unknown, Value>;
    getParentLinkAndSegmentGetter(): [(match: unknown) => Segment, BuilderLink<ActionResult, Segment, Value>] | undefined;
    getBuilderLink(): this;
    register(builder: HasBuilderLink<ActionResult, Segment, Value>, resolveSegment: SegmentResolver<ActionResult, Segment, Value>): void;
    inherit(): BuilderLink<ActionResult, Segment, Value>;
}
//# sourceMappingURL=index.d.ts.map