"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Link = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _getRouteRecordLocation = require("../../builder/RouteRecord/getRouteRecordLocation");

var _locationToURL = require("../../util/locationToURL");

var _RouteContext = require("../contexts/RouteContext");

var _useNavigate = require("../hooks/useNavigate");

var _getNavigationBaseLocation = require("../logic/getNavigationBaseLocation");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/**
 * Renders an <a> element to given route.
 */
const RawLink = ({
  route,
  match,
  ...props
}, ref) => {
  const parentRoute = (0, _react.useContext)(_RouteContext.RouteContext);
  const navigate = (0, _useNavigate.useNavigate)();
  const href = (0, _react.useMemo)(() => {
    const baseLocation = (0, _getNavigationBaseLocation.getNavigationBaseLocation)(parentRoute, route);
    const location = (0, _getRouteRecordLocation.getRouteRecordLocation)(route, match || {}, baseLocation);
    return (0, _locationToURL.locationToURL)(location);
  }, [route, match, parentRoute]);
  return /*#__PURE__*/_react.default.createElement("a", (0, _extends2.default)({
    ref: ref,
    href: href,
    onClick: e => {
      if (!isModifiedEvent(e)) {
        e.preventDefault(); // eslint-disable-next-line @typescript-eslint/no-explicit-any

        navigate(route, match);
      }
    }
  }, props));
};

const Link = /*#__PURE__*/(0, _react.forwardRef)(RawLink);
exports.Link = Link;

function isModifiedEvent(event) {
  return event.metaKey || event.altKey || event.ctrlKey || event.shiftKey;
}