"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RoconRoot = void 0;

var _history = require("history");

var _react = _interopRequireWildcard(require("react"));

var _HistoryContext = require("../contexts/HistoryContext");

var _LocationContext = require("../contexts/LocationContext");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const RoconRoot = /*#__PURE__*/(0, _react.memo)(props => {
  const history = (0, _react.useMemo)(() => props.history || (0, _history.createBrowserHistory)(), [props.history]);
  const historyContextValue = (0, _react.useMemo)(() => {
    return {
      history
    };
  }, [history]);
  const [location, setLocation] = (0, _react.useState)(history.location);
  (0, _react.useEffect)(() => {
    // this `setLocation` handles the case where location is changed after above `history.location` is calculated
    setLocation(history.location);
    return history.listen(state => {
      setLocation(state.location);
    });
  }, [history]);
  return /*#__PURE__*/_react.default.createElement(_HistoryContext.HistoryContext.Provider, {
    value: historyContextValue
  }, /*#__PURE__*/_react.default.createElement(_LocationContext.LocationContext.Provider, {
    value: location
  }, props.children));
});
exports.RoconRoot = RoconRoot;