import type { PathRouteBuilder } from "../builder/PathRouteBuilder";
import type { RootRouteBuilder, RootRouteBuilderOptions } from "../builder/RootRouteBuilder";
import type { SearchRouteBuilder, SearchRouteBuilderOptions } from "../builder/SearchRouteBuilder";
import type { SingleHashRouteBuilder, SingleHashRouteBuilderOptions } from "../builder/SingleHashRouteBuilder";
import type { StateRouteBuilder, StateRouteBuilerOptions } from "../builder/StateRouteBuilder";
import type { OptionalIf } from "../util/types/OptionalIf";
import type { PartialIf } from "../util/types/PartialIf";
import type { Validator } from "../validator";
import type { ReactElement } from "./types/ReactElement";
declare type ActionResult = ReactElement | null;
export declare const Path: () => PathRouteBuilder<ActionResult, {}, "none", "none", {}, {}>;
export declare const Search: <Key extends string, IsOptional extends boolean = false>(matchKey: Key, options?: SearchRouteBuilderOptions<IsOptional>) => SearchRouteBuilder<ActionResult, "noaction", PartialIf<IsOptional, {
    [K in Key]: string;
}>>;
export declare const State: <StateValue, Key extends string, IsOptional extends boolean = false>(matchKey: Key, validator: Validator<StateValue>, options?: StateRouteBuilerOptions<IsOptional>) => StateRouteBuilder<ActionResult, OptionalIf<IsOptional, StateValue>, "noaction", PartialIf<IsOptional, {
    [K in Key]: StateValue;
}>>;
export declare const Root: (options?: Partial<RootRouteBuilderOptions>) => RootRouteBuilder<ActionResult, "noaction", {}>;
export declare const SingleHash: <Key extends string, IsOptional extends boolean = false>(matchKey: Key, options?: SingleHashRouteBuilderOptions<IsOptional>) => SingleHashRouteBuilder<ActionResult, "noaction", PartialIf<IsOptional, {
    [K in Key]: string;
}>>;
export {};
//# sourceMappingURL=shorthand.d.ts.map